#include <bits/stdc++.h>
using namespace std;
int main(){
    long long int n,m,i,j,c,x=0;
    cin>>n>>m;
    long long int b[m+1],a[n+1];
    for(i=1;i<=m;i++)
    cin>>b[i];
    cin>>c;
    for(i=1;i<=n;i++)
    a[i]=i;
    for(i=0;i<=n-m;i++)
    for(j=1;j<=m;j++)
    a[i+b[j]]=a[i+j];
    for(i=1;i<=n;i++)
    x+=pow(c,i)*a[i];
    cout<<x%998244353;
    
}